searchData={"items":[{"type":"module","title":"Cldr.Decimal","doc":"Adds a compatibility layer for functions which changed\neither semantics or returns types between Decimal version\n1.x and 2.x.","ref":"Cldr.Decimal.html"},{"type":"function","title":"Cldr.Decimal.compare/2","doc":"","ref":"Cldr.Decimal.html#compare/2"},{"type":"function","title":"Cldr.Decimal.parse/1","doc":"","ref":"Cldr.Decimal.html#parse/1"},{"type":"function","title":"Cldr.Decimal.reduce/1","doc":"","ref":"Cldr.Decimal.html#reduce/1"},{"type":"module","title":"Cldr.Digits","doc":"Abstract representation of number (integer, float, Decimal) in tuple form\nand functions for transformations on number parts.\n\nRepresenting a number as a list of its digits, and integer representing\nwhere the decimal point is placed and an integer representing the sign\nof the number allow more efficient transforms on the various parts of\nthe number as happens during the formatting of a number for string output.","ref":"Cldr.Digits.html"},{"type":"function","title":"Cldr.Digits.fixup/8","doc":"","ref":"Cldr.Digits.html#fixup/8"},{"type":"function","title":"Cldr.Digits.fraction_as_integer/1","doc":"Returns the fractional part of an integer, float or Decimal as an integer.\n\n* `number` can be either a float, Decimal or integer although an integer has\n  no fraction part and will therefore always return 0.","ref":"Cldr.Digits.html#fraction_as_integer/1"},{"type":"function","title":"Examples - Cldr.Digits.fraction_as_integer/1","doc":"iex> Cldr.Digits.fraction_as_integer(123.456)\n    456\n\n    iex> Cldr.Digits.fraction_as_integer(Decimal.new(\"123.456\"))\n    456\n\n    iex> Cldr.Digits.fraction_as_integer(1999)\n    0","ref":"Cldr.Digits.html#fraction_as_integer/1-examples"},{"type":"function","title":"Cldr.Digits.fraction_as_integer/2","doc":"","ref":"Cldr.Digits.html#fraction_as_integer/2"},{"type":"function","title":"Cldr.Digits.frexp/3","doc":"","ref":"Cldr.Digits.html#frexp/3"},{"type":"function","title":"Cldr.Digits.number_of_digits/1","doc":"Returns the number of decimal digits in a number\n(integer, float, Decimal)","ref":"Cldr.Digits.html#number_of_digits/1"},{"type":"function","title":"Options - Cldr.Digits.number_of_digits/1","doc":"* `number` is an integer, float or `Decimal`\nor a list (which is assumed to contain digits).","ref":"Cldr.Digits.html#number_of_digits/1-options"},{"type":"function","title":"Examples - Cldr.Digits.number_of_digits/1","doc":"iex> Cldr.Digits.number_of_digits(1234)\n    4\n\n    iex> Cldr.Digits.number_of_digits(Decimal.new(\"123456789\"))\n    9\n\n    iex> Cldr.Digits.number_of_digits(1234.456)\n    7\n\n    iex> Cldr.Digits.number_of_digits(1234.56789098765)\n    15\n\n    iex> Cldr.Digits.number_of_digits(~c\"12345\")\n    5","ref":"Cldr.Digits.html#number_of_digits/1-examples"},{"type":"function","title":"Cldr.Digits.number_of_integer_digits/1","doc":"Returns the number of decimal digits in the integer\npart of a number.","ref":"Cldr.Digits.html#number_of_integer_digits/1"},{"type":"function","title":"Options - Cldr.Digits.number_of_integer_digits/1","doc":"* `number` is an integer, float or `Decimal` or\na list (which is assumed to contain digits).","ref":"Cldr.Digits.html#number_of_integer_digits/1-options"},{"type":"function","title":"Examples - Cldr.Digits.number_of_integer_digits/1","doc":"iex> Cldr.Digits.number_of_integer_digits(1234)\n    4\n\n    iex> Cldr.Digits.number_of_integer_digits(Decimal.new(\"123456789\"))\n    9\n\n    iex> Cldr.Digits.number_of_integer_digits(1234.456)\n    4\n\n    iex> Cldr.Digits.number_of_integer_digits(~c\"12345\")\n    5","ref":"Cldr.Digits.html#number_of_integer_digits/1-examples"},{"type":"function","title":"Cldr.Digits.number_of_leading_zeros/1","doc":"Returns the number of leading zeros in a\nDecimal fraction.\n\n* `number` is an integer, float or Decimal\n\nReturns the number of leading zeros in the fractional\npart of a number.","ref":"Cldr.Digits.html#number_of_leading_zeros/1"},{"type":"function","title":"Examples - Cldr.Digits.number_of_leading_zeros/1","doc":"iex> Cldr.Digits.number_of_leading_zeros(Decimal.new(\"0.0001\"))\n    3","ref":"Cldr.Digits.html#number_of_leading_zeros/1-examples"},{"type":"function","title":"Cldr.Digits.number_of_trailing_zeros/1","doc":"Returns the number of trailing zeros in an\ninteger number.\n\n* `number` is an integer.\n\nReturns the number of trailing zeros in the fractional\npart of an integer.","ref":"Cldr.Digits.html#number_of_trailing_zeros/1"},{"type":"function","title":"Examples - Cldr.Digits.number_of_trailing_zeros/1","doc":"iex> Cldr.Digits.number_of_trailing_zeros(123000)\n    3","ref":"Cldr.Digits.html#number_of_trailing_zeros/1-examples"},{"type":"function","title":"Cldr.Digits.remove_trailing_zeros/1","doc":"Remove trailing zeroes from the integer part of a number\nand returns the integer part without trailing zeros.\n\n* `number` is an integer, float or Decimal.","ref":"Cldr.Digits.html#remove_trailing_zeros/1"},{"type":"function","title":"Examples - Cldr.Digits.remove_trailing_zeros/1","doc":"iex> Cldr.Digits.remove_trailing_zeros(1234000)\n    1234","ref":"Cldr.Digits.html#remove_trailing_zeros/1-examples"},{"type":"function","title":"Cldr.Digits.scale/7","doc":"","ref":"Cldr.Digits.html#scale/7"},{"type":"function","title":"Cldr.Digits.to_decimal/1","doc":"","ref":"Cldr.Digits.html#to_decimal/1"},{"type":"function","title":"Cldr.Digits.to_digits/1","doc":"Computes a iodata list of the digits of the given IEEE 754 floating point number,\ntogether with the location of the decimal point as {digits, place, positive}.\n\nA \"compact\" representation is returned, so there may be fewer digits returned\nthan the decimal point location.","ref":"Cldr.Digits.html#to_digits/1"},{"type":"function","title":"Cldr.Digits.to_float/1","doc":"","ref":"Cldr.Digits.html#to_float/1"},{"type":"function","title":"Cldr.Digits.to_integer/1","doc":"","ref":"Cldr.Digits.html#to_integer/1"},{"type":"function","title":"Cldr.Digits.to_number/2","doc":"Takes a list of digits and coverts them back to a number of the same\ntype as `number`.","ref":"Cldr.Digits.html#to_number/2"},{"type":"function","title":"Cldr.Digits.to_tuple/1","doc":"Converts given number to a list representation.\n\nGiven an IEEE 754 float, computes the shortest, correctly rounded list of\ndigits that converts back to the same Double value when read back with\nString.to_float/1.  Implements the algorithm from \"Printing Floating-Point\nNumbers Quickly and Accurately\" in Proceedings of the SIGPLAN '96 Conference\non Programming Language Design and Implementation.\n\nReturns a tuple comprising a charlist for the integer part,\na charlist for the fractional part and an integer for the sign.","ref":"Cldr.Digits.html#to_tuple/1"},{"type":"type","title":"Cldr.Digits.t/0","doc":"Defines a number in a tuple form of three parts:\n\n* A list of digits (0..9) representing the number\n\n* A digit representing the place of the decimal points\nin the number\n\n* a `1` or `-1` representing the sign of the number\n\nA number in integer, float or Decimal form can be converted\nto digit form with `Digits.to_digits/1`.\n\nThe digits can be converted back to normal form with\n`Cldr.Digits.to_integer/1`, `Cldr.Digits.to_float/1` and\n`Cldr.Digits.to_decimal/1`.","ref":"Cldr.Digits.html#t:t/0"},{"type":"module","title":"Cldr.Enum","doc":"","ref":"Cldr.Enum.html"},{"type":"function","title":"Cldr.Enum.combine_list/1","doc":"","ref":"Cldr.Enum.html#combine_list/1"},{"type":"function","title":"Cldr.Enum.reduce_peeking/3","doc":"Very simple reduce that passes both the head and the tail\nto the reducing function so it has some lookahead.","ref":"Cldr.Enum.html#reduce_peeking/3"},{"type":"module","title":"Cldr.Helpers","doc":"General purpose helper functions for CLDR","ref":"Cldr.Helpers.html"},{"type":"function","title":"Cldr.Helpers.empty?/1","doc":"Returns a boolean indicating if a data\nstructure is semanically empty.\n\nApplies to lists, maps and `nil`","ref":"Cldr.Helpers.html#empty?/1"},{"type":"module","title":"Cldr.Http","doc":"Supports securely downloading https content.","ref":"Cldr.Http.html"},{"type":"function","title":"Cldr.Http.certificate_locations/0","doc":"","ref":"Cldr.Http.html#certificate_locations/0"},{"type":"function","title":"Cldr.Http.get/2","doc":"Securely download https content from\na URL.\n\nThis function uses the built-in `:httpc`\nclient but enables certificate verification\nwhich is not enabled by `:httc` by default.\n\nSee also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl\n\n#","ref":"Cldr.Http.html#get/2"},{"type":"function","title":"Arguments - Cldr.Http.get/2","doc":"* `url` is a binary URL or a `{url, list_of_headers}` tuple. If\n  provided the headers are a list of `{'header_name', 'header_value'}`\n  tuples. Note that the name and value are both charlists, not\n  strings.\n\n* `options` is a keyword list of options.\n\n#","ref":"Cldr.Http.html#get/2-arguments"},{"type":"function","title":"Options - Cldr.Http.get/2","doc":"* `:verify_peer` is a boolean value indicating\n  if peer verification should be done for this request.\n  The default is `true` in which case the default\n  `:ssl` options follow the [erlef guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl)\n  noted above.\n\n* `:timeout` is the number of milliseconds available\n  for the request to complete. The default is\n  \"120000\". This option may also be\n  set with the `CLDR_HTTP_TIMEOUT` environment variable.\n\n* `:connection_timeout` is the number of milliseconds\n  available for the a connection to be estabklished to\n  the remote host. The default is \"60000\".\n  This option may also be set with the\n  `CLDR_HTTP_CONNECTION_TIMEOUT` environment variable.\n\n#","ref":"Cldr.Http.html#get/2-options"},{"type":"function","title":"Returns - Cldr.Http.get/2","doc":"* `{:ok, body}` if the return is successful.\n\n* `{:not_modified, headers}` if the request would result in\n  returning the same results as one matching an etag.\n\n* `{:error, error}` if the download is\n   unsuccessful. An error will also be logged\n   in these cases.\n\n#","ref":"Cldr.Http.html#get/2-returns"},{"type":"function","title":"Unsafe HTTPS - Cldr.Http.get/2","doc":"If the environment variable `CLDR_UNSAFE_HTTPS` is\nset to anything other than `FALSE`, `false`, `nil`\nor `NIL` then no peer verification of certificates\nis performed. Setting this variable is not recommended\nbut may be required is where peer verification for\nunidentified reasons. Please [open an issue](https://github.com/elixir-cldr/cldr/issues)\nif this occurs.\n\n#","ref":"Cldr.Http.html#get/2-unsafe-https"},{"type":"function","title":"Certificate stores - Cldr.Http.get/2","doc":"In order to keep dependencies to a minimum,\n`get/1` attempts to locate an already installed\ncertificate store. It will try to locate a\nstore in the following order which is intended\nto satisfy most host systems. The certificate\nstore is expected to be a path name on the\nhost system.\n\n```elixir\n# A certificate store configured by the\n# developer\nApplication.get_env(:ex_cldr, :cacertfile)\n\n# Populated if hex package `CAStore` is configured\nCAStore.file_path()\n\n# Populated if hex package `certfi` is configured\n:certifi.cacertfile()\n\n# Debian/Ubuntu/Gentoo etc.\n\"/etc/ssl/certs/ca-certificates.crt\",\n\n# Fedora/RHEL 6\n\"/etc/pki/tls/certs/ca-bundle.crt\",\n\n# OpenSUSE\n\"/etc/ssl/ca-bundle.pem\",\n\n# OpenELEC\n\"/etc/pki/tls/cacert.pem\",\n\n# CentOS/RHEL 7\n\"/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem\",\n\n# Open SSL on MacOS\n\"/usr/local/etc/openssl/cert.pem\",\n\n# MacOS & Alpine Linux\n\"/etc/ssl/cert.pem\"\n```","ref":"Cldr.Http.html#get/2-certificate-stores"},{"type":"function","title":"Cldr.Http.get_with_headers/2","doc":"Securely download https content from\na URL.\n\nThis function uses the built-in `:httpc`\nclient but enables certificate verification\nwhich is not enabled by `:httc` by default.\n\nSee also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl\n\n#","ref":"Cldr.Http.html#get_with_headers/2"},{"type":"function","title":"Arguments - Cldr.Http.get_with_headers/2","doc":"* `url` is a binary URL or a `{url, list_of_headers}` tuple. If\n  provided the headers are a list of `{'header_name', 'header_value'}`\n  tuples. Note that the name and value are both charlists, not\n  strings.\n\n* `options` is a keyword list of options.\n\n#","ref":"Cldr.Http.html#get_with_headers/2-arguments"},{"type":"function","title":"Options - Cldr.Http.get_with_headers/2","doc":"* `:verify_peer` is a boolean value indicating\n  if peer verification should be done for this request.\n  The default is `true` in which case the default\n  `:ssl` options follow the [erlef guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl)\n  noted above.\n\n* `:timeout` is the number of milliseconds available\n  for the request to complete. The default is\n  \"120000\". This option may also be\n  set with the `CLDR_HTTP_TIMEOUT` environment variable.\n\n* `:connection_timeout` is the number of milliseconds\n  available for the a connection to be estabklished to\n  the remote host. The default is \"60000\".\n  This option may also be set with the\n  `CLDR_HTTP_CONNECTION_TIMEOUT` environment variable.\n\n* `:https_proxy` is the URL of an https proxy to be used. The\n  default is `nil`.\n\n#","ref":"Cldr.Http.html#get_with_headers/2-options"},{"type":"function","title":"Returns - Cldr.Http.get_with_headers/2","doc":"* `{:ok, body, headers}` if the return is successful.\n\n* `{:not_modified, headers}` if the request would result in\n  returning the same results as one matching an etag.\n\n* `{:error, error}` if the download is\n   unsuccessful. An error will also be logged\n   in these cases.\n\n#","ref":"Cldr.Http.html#get_with_headers/2-returns"},{"type":"function","title":"Unsafe HTTPS - Cldr.Http.get_with_headers/2","doc":"If the environment variable `CLDR_UNSAFE_HTTPS` is\nset to anything other than `FALSE`, `false`, `nil`\nor `NIL` then no peer verification of certificates\nis performed. Setting this variable is not recommended\nbut may be required is where peer verification for\nunidentified reasons. Please [open an issue](https://github.com/elixir-cldr/cldr/issues)\nif this occurs.\n\n#","ref":"Cldr.Http.html#get_with_headers/2-unsafe-https"},{"type":"function","title":"Https Proxy - Cldr.Http.get_with_headers/2","doc":"`Cldr.Http.get/2` will look for a proxy URL in the following\nlocales in the order presented:\n\n* `options[:https_proxy]`\n* `ex_cldr` compile-time configuration under the\n  key `:ex_cldr[:https_proxy]`\n* The environment variable `HTTPS_PROXY`\n* The environment variable `https_proxy`\n\n#","ref":"Cldr.Http.html#get_with_headers/2-https-proxy"},{"type":"function","title":"Certificate stores - Cldr.Http.get_with_headers/2","doc":"In order to keep dependencies to a minimum,\n`get/1` attempts to locate an already installed\ncertificate store. It will try to locate a\nstore in the following order which is intended\nto satisfy most host systems. The certificate\nstore is expected to be a path name on the\nhost system.\n\n```elixir\n# A certificate store configured by the\n# developer\nApplication.get_env(:ex_cldr, :cacertfile)\n\n# Populated if hex package `CAStore` is configured\nCAStore.file_path()\n\n# Populated if hex package `certfi` is configured\n:certifi.cacertfile()\n\n# Debian/Ubuntu/Gentoo etc.\n\"/etc/ssl/certs/ca-certificates.crt\",\n\n# Fedora/RHEL 6\n\"/etc/pki/tls/certs/ca-bundle.crt\",\n\n# OpenSUSE\n\"/etc/ssl/ca-bundle.pem\",\n\n# OpenELEC\n\"/etc/pki/tls/cacert.pem\",\n\n# CentOS/RHEL 7\n\"/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem\",\n\n# Open SSL on MacOS\n\"/usr/local/etc/openssl/cert.pem\",\n\n# MacOS & Alpine Linux\n\"/etc/ssl/cert.pem\"\n```","ref":"Cldr.Http.html#get_with_headers/2-certificate-stores"},{"type":"function","title":"Cldr.Http.otp_version/0","doc":"","ref":"Cldr.Http.html#otp_version/0"},{"type":"module","title":"Cldr.Map","doc":"Functions for transforming maps, keys and values.","ref":"Cldr.Map.html"},{"type":"function","title":"Cldr.Map.atomize_keys/2","doc":"Transforms a `map`'s `String.t` keys to `atom()` keys.","ref":"Cldr.Map.html#atomize_keys/2"},{"type":"function","title":"Arguments - Cldr.Map.atomize_keys/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`. One additional option apples\n  to this function directly:\n\n  * `:only_existing` which is set to `true` will\n    only convert the binary value to an atom if the atom\n    already exists.  The default is `false`.","ref":"Cldr.Map.html#atomize_keys/2-arguments"},{"type":"function","title":"Example - Cldr.Map.atomize_keys/2","doc":"iex> Cldr.Map.atomize_keys %{\"a\" => %{\"b\" => %{1 => \"c\"}}}\n    %{a: %{b: %{1 => \"c\"}}}","ref":"Cldr.Map.html#atomize_keys/2-example"},{"type":"function","title":"Cldr.Map.atomize_values/2","doc":"Transforms a `map`'s `String.t` values to `atom()` values.","ref":"Cldr.Map.html#atomize_values/2"},{"type":"function","title":"Arguments - Cldr.Map.atomize_values/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`. One additional option apples\n  to this function directly:\n\n  * `:only_existing` which is set to `true` will\n    only convert the binary value to an atom if the atom\n    already exists.  The default is `false`.","ref":"Cldr.Map.html#atomize_values/2-arguments"},{"type":"function","title":"Examples - Cldr.Map.atomize_values/2","doc":"iex> Cldr.Map.atomize_values %{\"a\" => %{\"b\" => %{1 => \"c\"}}}\n    %{\"a\" => %{\"b\" => %{1 => :c}}}","ref":"Cldr.Map.html#atomize_values/2-examples"},{"type":"function","title":"Cldr.Map.combine_list_resolver/3","doc":"","ref":"Cldr.Map.html#combine_list_resolver/3"},{"type":"function","title":"Cldr.Map.deep_map/3","doc":"Recursively traverse a map and invoke a function\nthat transforms the mapfor each key/value pair.","ref":"Cldr.Map.html#deep_map/3"},{"type":"function","title":"Arguments - Cldr.Map.deep_map/3","doc":"* `map` is any `t:map/0`\n\n* `function` is a `1-arity` function or function reference that\n  is called for each key/value pair of the provided map. It can\n  also be a 2-tuple of the form `{key_function, value_function}`\n\n  * In the case where `function` is a single function it will be\n    called with the 2-tuple argument `{key, value}`\n\n  * In the case where function is of the form `{key_function, value_function}`\n    the `key_function` will be called with the argument `key` and the value\n    function will be called with the argument `value`\n\n* `options` is a keyword list of options. The default is\n  `[level: 1..1000000, filter: [], reject: [], skip: [], only: [], except: []]`","ref":"Cldr.Map.html#deep_map/3-arguments"},{"type":"function","title":"Options - Cldr.Map.deep_map/3","doc":"* `:level` indicates the starting (and optionally ending) levels of\n  the map at which the `function` is executed. This can\n  be an integer representing one `level` or a range\n  indicating a range of levels. The default is `1..1000000`\n\n* `:only` is a term or list of terms or a `check function`. If it is a term\n  or list of terms, the `function` is only called if the `key` of the\n  map is equal to the term or in the list of terms. If `:only` is a\n  `check function` then the `check function` is passed the `{k, v}` of\n  the current branch in the `map`. It is expected to return a `truthy`\n  value that if `true` signals that the argument `function` will be executed.\n\n* `:except` is a term or list of terms or a `check function`. If it is a term\n  or list of terms, the `function` is only called if the `key` of the\n  map is not equal to the term or not in the list of terms. If `:except` is a\n  `check function` then the `check function` is passed the `{k, v}` of\n  the current branch in the `map`. It is expected to return a `truthy`\n  value that if `true` signals that the argument `function` will not be executed.\n\n* `:filter` is a term or list of terms or a `check function`. If the\n  `key` currently being processed equals the term (or is in the list of\n  terms, or the `check_function` returns a truthy value) then this branch\n  of the map is processed by `function` and its output is included in the result.\n\n* `:reject` is a term or list of terms or a `check function`. If the\n  `key` currently being processed equals the term (or is in the list of\n  terms, or the `check_function` returns a truthy value) then this branch\n  of the map is omitted from the mapped output.\n\n* `:skip` is a term or list of terms or a `check function`. If the\n  `key` currently being processed equals the term (or is in the list of\n  terms, or the `check_function` returns a truthy value) then this branch\n  of the map is *not* processed by `function` but it is included in\n  the mapped result.","ref":"Cldr.Map.html#deep_map/3-options"},{"type":"function","title":"Notes - Cldr.Map.deep_map/3","doc":"* `:only` and `:except` operate on individual keys whereas `:filter`\n  and `:filter` and `:reject` operator on *entire branches* of a map\n\n* If both the options `:only` and `:except` are provided then the `function`\n  is called only when a `term` meets both criteria. That means that `:except`\n  has priority over `:only`.\n\n* If both the options `:filter` and `:reject` are provided then `:reject`\n  has priority over `:filter`.","ref":"Cldr.Map.html#deep_map/3-notes"},{"type":"function","title":"Returns - Cldr.Map.deep_map/3","doc":"* The `map` transformed by the recursive application of\n  `function`","ref":"Cldr.Map.html#deep_map/3-returns"},{"type":"function","title":"Examples - Cldr.Map.deep_map/3","doc":"iex> map = %{a: :a, b: %{c: :c}}\n    iex> fun = fn\n    ...>   {k, v} when is_atom(k) -> {Atom.to_string(k), v}\n    ...>   other -> other\n    ...> end\n    iex> Cldr.Map.deep_map map, fun\n    %{\"a\" => :a, \"b\" => %{\"c\" => :c}}\n    iex> map = %{a: :a, b: %{c: :c}}\n    iex> Cldr.Map.deep_map map, fun, only: :c\n    %{a: :a, b: %{\"c\" => :c}}\n    iex> Cldr.Map.deep_map map, fun, except: [:a, :b]\n    %{a: :a, b: %{\"c\" => :c}}\n    iex> Cldr.Map.deep_map map, fun, level: 2\n    %{a: :a, b: %{\"c\" => :c}}","ref":"Cldr.Map.html#deep_map/3-examples"},{"type":"function","title":"Cldr.Map.deep_merge/3","doc":"Deep merge two maps\n\n* `left` is any `t:map/0`\n\n* `right` is any `t:map/0`","ref":"Cldr.Map.html#deep_merge/3"},{"type":"function","title":"Examples - Cldr.Map.deep_merge/3","doc":"iex> Cldr.Map.deep_merge %{a: \"a\", b: \"b\"}, %{c: \"c\", d: \"d\"}\n    %{a: \"a\", b: \"b\", c: \"c\", d: \"d\"}\n\n    iex> Cldr.Map.deep_merge %{a: \"a\", b: \"b\"}, %{c: \"c\", d: \"d\", a: \"aa\"}\n    %{a: \"aa\", b: \"b\", c: \"c\", d: \"d\"}","ref":"Cldr.Map.html#deep_merge/3-examples"},{"type":"function","title":"Cldr.Map.delete_in/2","doc":"Delete all members of a map that have a\nkey in the list of keys","ref":"Cldr.Map.html#delete_in/2"},{"type":"function","title":"Examples - Cldr.Map.delete_in/2","doc":"iex> Cldr.Map.delete_in %{a: \"a\", b: \"b\"}, [:a]\n    %{b: \"b\"}","ref":"Cldr.Map.html#delete_in/2-examples"},{"type":"function","title":"Cldr.Map.extract_strings/2","doc":"Extract strings from a map or list\n\nRecursively process the map or list\nand extract string values from maps\nand string elements from lists","ref":"Cldr.Map.html#extract_strings/2"},{"type":"function","title":"Cldr.Map.floatize_keys/2","doc":"Transforms a `map`'s `String.t` keys to `Float.t` values.","ref":"Cldr.Map.html#floatize_keys/2"},{"type":"function","title":"Arguments - Cldr.Map.floatize_keys/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`\n\nThe map key is converted to a `float` from\na `String.t` only when the key is comprised of\na valid float form.\n\nKeys which cannot be converted to a `float`\nare returned unchanged.","ref":"Cldr.Map.html#floatize_keys/2-arguments"},{"type":"function","title":"Examples - Cldr.Map.floatize_keys/2","doc":"iex> Cldr.Map.floatize_keys %{a: %{\"1.0\" => \"value\"}}\n    %{a: %{1.0 => \"value\"}}\n\n    iex> Cldr.Map.floatize_keys %{a: %{\"1\" => \"value\"}}\n    %{a: %{1.0 => \"value\"}}","ref":"Cldr.Map.html#floatize_keys/2-examples"},{"type":"function","title":"Cldr.Map.floatize_values/2","doc":"Transforms a `map`'s `String.t` values to `Float.t` values.","ref":"Cldr.Map.html#floatize_values/2"},{"type":"function","title":"Arguments - Cldr.Map.floatize_values/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`\n\nThe map value is converted to a `float` from\na `String.t` only when the\nvalue is comprised of a valid float form.\n\nValues which cannot be converted to a `float`\nare returned unchanged.","ref":"Cldr.Map.html#floatize_values/2-arguments"},{"type":"function","title":"Examples - Cldr.Map.floatize_values/2","doc":"iex> Cldr.Map.floatize_values %{a: %{b: \"1.0\"}}\n    %{a: %{b: 1.0}}\n\n    iex> Cldr.Map.floatize_values %{a: %{b: \"1\"}}\n    %{a: %{b: 1.0}}","ref":"Cldr.Map.html#floatize_values/2-examples"},{"type":"function","title":"Cldr.Map.from_keyword/1","doc":"","ref":"Cldr.Map.html#from_keyword/1"},{"type":"function","title":"Cldr.Map.identity/1","doc":"Returns am argument unchanged.\n\nUseful when a `noop` function is required.","ref":"Cldr.Map.html#identity/1"},{"type":"function","title":"Cldr.Map.integerize_keys/2","doc":"Transforms a `map`'s `String.t` keys to `Integer.t` keys.","ref":"Cldr.Map.html#integerize_keys/2"},{"type":"function","title":"Arguments - Cldr.Map.integerize_keys/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`\n\nThe map key is converted to an `integer` from\neither an `atom` or `String.t` only when the\nkey is comprised of `integer` digits.\n\nKeys which cannot be converted to an `integer`\nare returned unchanged.","ref":"Cldr.Map.html#integerize_keys/2-arguments"},{"type":"function","title":"Example - Cldr.Map.integerize_keys/2","doc":"iex> Cldr.Map.integerize_keys %{a: %{\"1\" => \"value\"}}\n    %{a: %{1 => \"value\"}}","ref":"Cldr.Map.html#integerize_keys/2-example"},{"type":"function","title":"Cldr.Map.integerize_values/2","doc":"Transforms a `map`'s `String.t` values to `Integer.t` values.","ref":"Cldr.Map.html#integerize_values/2"},{"type":"function","title":"Arguments - Cldr.Map.integerize_values/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`\n\nThe map value is converted to an `integer` from\neither an `atom` or `String.t` only when the\nvalue is comprised of `integer` digits.\n\nKeys which cannot be converted to an integer\nare returned unchanged.","ref":"Cldr.Map.html#integerize_values/2-arguments"},{"type":"function","title":"Example - Cldr.Map.integerize_values/2","doc":"iex> Cldr.Map.integerize_values %{a: %{b: \"1\"}}\n    %{a: %{b: 1}}","ref":"Cldr.Map.html#integerize_values/2-example"},{"type":"function","title":"Cldr.Map.invert/2","doc":"Invert a map\n\nRequires that the map is a simple map of\nkeys and a list of values or a single\nnon-map value","ref":"Cldr.Map.html#invert/2"},{"type":"function","title":"Options - Cldr.Map.invert/2","doc":"* `:duplicates` which determines how duplicate values\n  are handled:\n  * `nil` or `false` which is the default and means only\n    one value is kept. `Map.new/1` is used meanng the\n    selected value is non-deterministic.\n  * `:keep` meaning duplicate values are returned in a list\n  * `:shortest` means the shortest duplicate is kept.\n    This operates on string or atom values.\n  * `:longest` means the shortest duplicate is kept.\n    This operates on string or atom values.","ref":"Cldr.Map.html#invert/2-options"},{"type":"function","title":"Cldr.Map.merge_map_list/2","doc":"Returns the result of deep merging a list of maps","ref":"Cldr.Map.html#merge_map_list/2"},{"type":"function","title":"Examples - Cldr.Map.merge_map_list/2","doc":"iex> Cldr.Map.merge_map_list [%{a: \"a\", b: \"b\"}, %{c: \"c\", d: \"d\"}]\n    %{a: \"a\", b: \"b\", c: \"c\", d: \"d\"}","ref":"Cldr.Map.html#merge_map_list/2-examples"},{"type":"function","title":"Cldr.Map.process_type/2","doc":"","ref":"Cldr.Map.html#process_type/2"},{"type":"function","title":"Cldr.Map.prune/2","doc":"Prune a potentially deeply nested map of some of\nits branches","ref":"Cldr.Map.html#prune/2"},{"type":"function","title":"Cldr.Map.remove_leading_underscores/2","doc":"Removes any leading underscores from `map`\n`String.t` keys.\n\n* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`","ref":"Cldr.Map.html#remove_leading_underscores/2"},{"type":"function","title":"Examples - Cldr.Map.remove_leading_underscores/2","doc":"iex> Cldr.Map.remove_leading_underscores %{\"a\" => %{\"_b\" => \"b\"}}\n    %{\"a\" => %{\"b\" => \"b\"}}","ref":"Cldr.Map.html#remove_leading_underscores/2-examples"},{"type":"function","title":"Cldr.Map.rename_keys/4","doc":"Rename map keys from `from` to `to`\n\n* `map` is any `t:map/0`\n\n* `from` is any value map key\n\n* `to` is any valid map key\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`","ref":"Cldr.Map.html#rename_keys/4"},{"type":"function","title":"Example - Cldr.Map.rename_keys/4","doc":"iex> Cldr.Map.rename_keys %{\"a\" => %{\"this_one\" => \"value\"}}, \"this_one\", \"that_one\"\n    %{\"a\" => %{\"that_one\" => \"value\"}}","ref":"Cldr.Map.html#rename_keys/4-example"},{"type":"function","title":"Cldr.Map.stringify_keys/2","doc":"Transforms a `map`'s `atom()` keys to `String.t` keys.","ref":"Cldr.Map.html#stringify_keys/2"},{"type":"function","title":"Arguments - Cldr.Map.stringify_keys/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`","ref":"Cldr.Map.html#stringify_keys/2-arguments"},{"type":"function","title":"Example - Cldr.Map.stringify_keys/2","doc":"iex> Cldr.Map.stringify_keys %{a: %{\"1\" => \"value\"}}\n    %{\"a\" => %{\"1\" => \"value\"}}","ref":"Cldr.Map.html#stringify_keys/2-example"},{"type":"function","title":"Cldr.Map.stringify_values/2","doc":"Transforms a `map`'s `atom()` keys to `String.t` keys.","ref":"Cldr.Map.html#stringify_values/2"},{"type":"function","title":"Arguments - Cldr.Map.stringify_values/2","doc":"* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`","ref":"Cldr.Map.html#stringify_values/2-arguments"},{"type":"function","title":"Example - Cldr.Map.stringify_values/2","doc":"iex> Cldr.Map.stringify_values %{a: %{\"1\" => :value}}\n    %{a: %{\"1\" => \"value\"}}","ref":"Cldr.Map.html#stringify_values/2-example"},{"type":"function","title":"Cldr.Map.underscore/1","doc":"Convert a camelCase string or atom to a snake_case\n\n* `string` is a `String.t` or `atom()` to be\n  transformed\n\nThis is the code of Macro.underscore with modifications.\nThe change is to cater for strings in the format:\n\n  This_That\n\nwhich in Macro.underscore gets formatted as\n\n  this__that (note the double underscore)\n\nwhen we actually want\n\n  that_that","ref":"Cldr.Map.html#underscore/1"},{"type":"function","title":"Examples - Cldr.Map.underscore/1","doc":"iex> Cldr.Map.underscore \"thisThat\"\n    \"this_that\"\n\n    iex> Cldr.Map.underscore \"This_That\"\n    \"this_that\"","ref":"Cldr.Map.html#underscore/1-examples"},{"type":"function","title":"Cldr.Map.underscore_keys/2","doc":"Convert map `String.t` keys from `camelCase` to `snake_case`\n\n* `map` is any `t:map/0`\n\n* `options` is a keyword list of options passed\n  to `deep_map/3`","ref":"Cldr.Map.html#underscore_keys/2"},{"type":"function","title":"Example - Cldr.Map.underscore_keys/2","doc":"iex> Cldr.Map.underscore_keys %{\"a\" => %{\"thisOne\" => \"value\"}}\n    %{\"a\" => %{\"this_one\" => \"value\"}}","ref":"Cldr.Map.html#underscore_keys/2-example"},{"type":"module","title":"Cldr.Math","doc":"Math helper functions for number formatting.","ref":"Cldr.Math.html"},{"type":"function","title":"Cldr.Math.add/2","doc":"Adds two numbers together.\n\nThe numbers can be integers, floats or Decimals.\nThe type of the return will be Decimal if the\neither of the arguments is a Decimal.\n\nIf both arguments are integers, the result will\nbe an integer. If either of the arguments is a float,\nthe result will be a float.","ref":"Cldr.Math.html#add/2"},{"type":"function","title":"Cldr.Math.amod/2","doc":"Returns the adjusted modulus of `x` and `y`.","ref":"Cldr.Math.html#amod/2"},{"type":"function","title":"Cldr.Math.coef_exponent/1","doc":"Returns a tuple representing a number in a normalized form with\nthe mantissa in the range `0 < m < 10` and a base 10 exponent.\n\n* `number` is an integer, float or Decimal","ref":"Cldr.Math.html#coef_exponent/1"},{"type":"function","title":"Examples - Cldr.Math.coef_exponent/1","doc":"Cldr.Math.coef_exponent(Decimal.new(1.23004))\n    {Decimal.new(\"1.23004\"), 0}\n\n    Cldr.Math.coef_exponent(Decimal.new(465))\n    {Decimal.new(\"4.65\"), 2}\n\n    Cldr.Math.coef_exponent(Decimal.new(-46.543))\n    {Decimal.new(\"-4.6543\"), 1}","ref":"Cldr.Math.html#coef_exponent/1-examples"},{"type":"function","title":"Cldr.Math.coef_exponent_digits/1","doc":"Returns a tuple representing a number in a normalized form with\nthe mantissa in the range `0 < m < 10` and a base 10 exponent.\n\nThe mantissa is represented as tuple of the form `Digits.t`.\n\n* `number` is an integer, float or Decimal","ref":"Cldr.Math.html#coef_exponent_digits/1"},{"type":"function","title":"Examples - Cldr.Math.coef_exponent_digits/1","doc":"Cldr.Math.coef_exponent_digits(Decimal.new(1.23004))\n    {{[1, 2, 3, 0], 1, 1}, 0}\n\n    Cldr.Math.coef_exponent_digits(Decimal.new(465))\n    {{[4, 6, 5], 1, 1}, -1}\n\n    Cldr.Math.coef_exponent_digits(Decimal.new(-46.543))\n    {{[4, 6, 5, 4], 1, -1}, 1}","ref":"Cldr.Math.html#coef_exponent_digits/1-examples"},{"type":"function","title":"Cldr.Math.default_rounding/0","doc":"Returns the default number of rounding digits.","ref":"Cldr.Math.html#default_rounding/0"},{"type":"function","title":"Cldr.Math.default_rounding_mode/0","doc":"Returns the default rounding mode for rounding operations.","ref":"Cldr.Math.html#default_rounding_mode/0"},{"type":"function","title":"Cldr.Math.div/2","doc":"Divides one number by the other.\n\nThe numbers can be integers, floats or Decimals.\nThe type of the return will be Decimal if the\neither of the arguments is a Decimal.\n\nIf both arguments are numbers, the resulting type\nwill be a be a Decimal.","ref":"Cldr.Math.html#div/2"},{"type":"function","title":"Cldr.Math.div_amod/2","doc":"Returns the adjusted remainder and dividend of two\nintegers.\n\nThis version will return the divisor if the remainder\nwould otherwise be zero.","ref":"Cldr.Math.html#div_amod/2"},{"type":"function","title":"Cldr.Math.div_mod/2","doc":"Returns the remainder and dividend of two integers.","ref":"Cldr.Math.html#div_mod/2"},{"type":"function","title":"Cldr.Math.log10/1","doc":"Return the log10 of a number.\n\n* `number` is an integer, a float or a Decimal\n\n  * For integer and float it calls the BIF `:math.log10/1` function.\n\n  * For `Decimal`, `log10` is is rolled by hand using the identify `log10(x) =\n  ln(x) / ln(10)`","ref":"Cldr.Math.html#log10/1"},{"type":"function","title":"Examples - Cldr.Math.log10/1","doc":"iex> Cldr.Math.log10(100)\n    2.0\n\n    iex> Cldr.Math.log10(123)\n    2.089905111439398\n\n    iex> Cldr.Math.log10(Decimal.new(9000))\n    Decimal.new(\"3.953767554157656512064441441\")","ref":"Cldr.Math.html#log10/1-examples"},{"type":"function","title":"Cldr.Math.log/1","doc":"Return the natural log of a number.\n\n* `number` is an integer, a float or a Decimal\n\n* For integer and float it calls the BIF `:math.log10/1` function.\n\n* For Decimal the log is rolled by hand.","ref":"Cldr.Math.html#log/1"},{"type":"function","title":"Examples - Cldr.Math.log/1","doc":"iex> Cldr.Math.log(123)\n    4.812184355372417\n\n    iex> Cldr.Math.log(Decimal.new(9000))\n    Decimal.new(\"9.103886231350952380952380952\")","ref":"Cldr.Math.html#log/1-examples"},{"type":"function","title":"Cldr.Math.maybe_integer/1","doc":"","ref":"Cldr.Math.html#maybe_integer/1"},{"type":"function","title":"Cldr.Math.mod/2","doc":"Calculates the modulo of a number (integer, float or Decimal).\n\nNote that this function uses `floored division` whereas the builtin `rem`\nfunction uses `truncated division`. See `Decimal.rem/2` if you want a\n`truncated division` function for Decimals that will return the same value as\nthe BIF `rem/2` but in Decimal form.\n\nSee [Wikipedia](https://en.wikipedia.org/wiki/Modulo_operation) for an\nexplanation of the difference.","ref":"Cldr.Math.html#mod/2"},{"type":"function","title":"Examples - Cldr.Math.mod/2","doc":"iex> Cldr.Math.mod(1234.0, 5)\n    4.0\n\n    iex> Cldr.Math.mod(Decimal.new(\"1234.456\"), 5)\n    Decimal.new(\"4.456\")\n\n    iex> Cldr.Math.mod(Decimal.new(\"123.456\"), Decimal.new(\"3.4\"))\n    Decimal.new(\"1.056\")\n\n    iex> Cldr.Math.mod Decimal.new(\"123.456\"), 3.4\n    Decimal.new(\"1.056\")","ref":"Cldr.Math.html#mod/2-examples"},{"type":"function","title":"Cldr.Math.mult/2","doc":"Multiplies two numbers together.\n\nThe numbers can be integers, floats or Decimals.\nThe type of the return will be Decimal if the\neither of the arguments is a Decimal.\n\nIf both arguments are integers, the result will\nbe an integer. If either of the arguments is a float,\nthe result will be a float.","ref":"Cldr.Math.html#mult/2"},{"type":"function","title":"Cldr.Math.pow/2","doc":"Raises one number to an exponent.","ref":"Cldr.Math.html#pow/2"},{"type":"function","title":"Cldr.Math.power/2","doc":"Raises a number to a integer power.\n\nRaises a number to a power using the the binary method. There is one\nexception for Decimal numbers that raise `10` to some power. In this case the\npower is calculated by shifting the Decimal exponent which is quite efficient.\n\nFor further reading see\n[this article](http://videlalvaro.github.io/2014/03/the-power-algorithm.html)\n\n> This function works only with integer exponents!","ref":"Cldr.Math.html#power/2"},{"type":"function","title":"Examples - Cldr.Math.power/2","doc":"iex> Cldr.Math.power(10, 2)\n    100\n\n    iex> Cldr.Math.power(10, 3)\n    1000\n\n    iex> Cldr.Math.power(10, 4)\n    10000\n\n    iex> Cldr.Math.power(2, 10)\n    1024","ref":"Cldr.Math.html#power/2-examples"},{"type":"function","title":"Cldr.Math.root/2","doc":"Calculate the nth root of a number.\n\n* `number` is an integer or a Decimal\n\n* `nth` is a positive integer","ref":"Cldr.Math.html#root/2"},{"type":"function","title":"Examples - Cldr.Math.root/2","doc":"iex> Cldr.Math.root Decimal.new(8), 3\n    Decimal.new(\"2.0\")\n\n    iex> Cldr.Math.root Decimal.new(16), 4\n    Decimal.new(\"2.0\")\n\n    iex> Cldr.Math.root Decimal.new(27), 3\n    Decimal.new(\"3.0\")","ref":"Cldr.Math.html#root/2-examples"},{"type":"function","title":"Cldr.Math.round/3","doc":"Round a number to an arbitrary precision using one of several rounding algorithms.\n\nRounding algorithms are based on the definitions given in IEEE 754, but also\ninclude 2 additional options (effectively the complementary versions):","ref":"Cldr.Math.html#round/3"},{"type":"function","title":"Arguments - Cldr.Math.round/3","doc":"* `number` is a `float`, `integer` or `Decimal`\n\n* `places` is an integer number of places to round to\n\n* `mode` is the rounding mode to be applied.  The\n  default is `:half_even`","ref":"Cldr.Math.html#round/3-arguments"},{"type":"function","title":"Rounding algorithms - Cldr.Math.round/3","doc":"Directed roundings:\n\n* `:down` - Round towards 0 (truncate), eg 10.9 rounds to 10.0\n\n* `:up` - Round away from 0, eg 10.1 rounds to 11.0. (Non IEEE algorithm)\n\n* `:ceiling` - Round toward +∞ - Also known as rounding up or ceiling\n\n* `:floor` - Round toward -∞ - Also known as rounding down or floor\n\nRound to nearest:\n\n* `:half_even` - Round to nearest value, but in a tiebreak, round towards the\n  nearest value with an even (zero) least significant bit, which occurs 50%\n  of the time. This is the default for IEEE binary floating-point and the recommended\n  value for decimal.\n\n* `:half_up` - Round to nearest value, but in a tiebreak, round away from 0.\n  This is the default algorithm for Erlang's Kernel.round/2\n\n* `:half_down` - Round to nearest value, but in a tiebreak, round towards 0\n  (Non IEEE algorithm)","ref":"Cldr.Math.html#round/3-rounding-algorithms"},{"type":"function","title":"Notes - Cldr.Math.round/3","doc":"* When the `number` is a `Decimal`, the results are identical\n  to `Decimal.round/3` (delegates to `Decimal` in these cases)\n\n* When the `number` is a `float`, `places` is `0` and `mode`\n  is `:half_up` then the result is the same as `Kernel.trunc/1`\n\n* The results of rounding for `floats` may not return the same\n  result as `Float.round/2`. `Float.round/2` operates on the\n  binary representation. This implementation operates on\n  a decimal representation.","ref":"Cldr.Math.html#round/3-notes"},{"type":"function","title":"Cldr.Math.round_significant/2","doc":"Rounds a number to a specified number of significant digits.\n\nThis is not the same as rounding fractional digits which is performed\nby `Decimal.round/2` and `Float.round`\n\n* `number` is a float, integer or Decimal\n\n* `n` is the number of significant digits to which the `number` should be\n  rounded","ref":"Cldr.Math.html#round_significant/2"},{"type":"function","title":"Examples - Cldr.Math.round_significant/2","doc":"iex> Cldr.Math.round_significant(3.14159, 3)\n    3.14\n\n    iex> Cldr.Math.round_significant(10.3554, 1)\n    10.0\n\n    iex> Cldr.Math.round_significant(0.00035, 1)\n    0.0004\n\n    iex> Cldr.Math.round_significant(Decimal.from_float(3.342742283480345e27), 7)\n    Decimal.new(\"3.342742E+27\")","ref":"Cldr.Math.html#round_significant/2-examples"},{"type":"function","title":"Notes about precision - Cldr.Math.round_significant/2","doc":"Since floats cannot accurately represent all decimal\nnumbers, so rounding to significant digits for a float cannot\nalways return the expected results. For example:\n\n    => Cldr.Math.round_significant(3.342742283480345e27, 7)\n    Expected result:  3.342742e27\n    Actual result: 3.3427420000000003e27\n\nUse of `Decimal` numbers avoids this issue:\n\n    => Cldr.Math.round_significant(Decimal.from_float(3.342742283480345e27), 7)\n    Expected result:  #Decimal<3.342742E+27>\n    Actual result: #Decimal<3.342742E+27>","ref":"Cldr.Math.html#round_significant/2-notes-about-precision"},{"type":"function","title":"More on significant digits - Cldr.Math.round_significant/2","doc":"* 3.14159 has six significant digits (all the numbers give you useful\n  information)\n\n* 1000 has one significant digit (only the 1 is interesting; you don't know\n  anything for sure about the hundreds, tens, or units places; the zeroes may\n  just be placeholders; they may have rounded something off to get this value)\n\n* 1000.0 has five significant digits (the \".0\" tells us something interesting\n  about the presumed accuracy of the measurement being made: that the\n  measurement is accurate to the tenths place, but that there happen to be\n  zero tenths)\n\n* 0.00035 has two significant digits (only the 3 and 5 tell us something; the\n  other zeroes are placeholders, only providing information about relative\n  size)\n\n* 0.000350 has three significant digits (that last zero tells us that the\n  measurement was made accurate to that last digit, which just happened to\n  have a value of zero)\n\n* 1006 has four significant digits (the 1 and 6 are interesting, and we have\n  to count the zeroes, because they're between the two interesting numbers)\n\n* 560 has two significant digits (the last zero is just a placeholder)\n\n* 560.0 has four significant digits (the zero in the tenths place means that\n  the measurement was made accurate to the tenths place, and that there just\n  happen to be zero tenths; the 5 and 6 give useful information, and the\n  other zero is between significant digits, and must therefore also be\n  counted)\n\nMany thanks to [Stackoverflow](http://stackoverflow.com/questions/202302/rounding-to-an-arbitrary-number-of-significant-digits)","ref":"Cldr.Math.html#round_significant/2-more-on-significant-digits"},{"type":"function","title":"Cldr.Math.sqrt/2","doc":"Calculates the square root of a Decimal number using Newton's method.\n\n* `number` is an integer, float or Decimal.  For integer and float,\n`sqrt` is delegated to the erlang `:math` module.\n\nWe convert the Decimal to a float and take its\n`:math.sqrt` only to get an initial estimate.\nThe means typically we are only two iterations from\na solution so the slight hack improves performance\nwithout sacrificing precision.","ref":"Cldr.Math.html#sqrt/2"},{"type":"function","title":"Examples - Cldr.Math.sqrt/2","doc":"iex> Cldr.Math.sqrt(Decimal.new(9))\n    Decimal.new(\"3.0\")\n\n    iex> Cldr.Math.sqrt(Decimal.new(\"9.869\"))\n    Decimal.new(\"3.141496458696078173887197038\")","ref":"Cldr.Math.html#sqrt/2-examples"},{"type":"function","title":"Cldr.Math.sub/2","doc":"Subtracts one number from another.\n\nThe numbers can be integers, floats or Decimals.\nThe type of the return will be Decimal if the\neither of the arguments is a Decimal.\n\nIf both arguments are integers, the result will\nbe an integer. If either of the arguments is a float,\nthe result will be a float.","ref":"Cldr.Math.html#sub/2"},{"type":"function","title":"Cldr.Math.to_float/1","doc":"Convert a Decimal to a float\n\n* `decimal` must be a Decimal\n\nThis is very likely to lose precision - lots of numbers won't\nmake the round trip conversion.  Use with care.  Actually, better\nnot to use it at all.","ref":"Cldr.Math.html#to_float/1"},{"type":"function","title":"Cldr.Math.within/2","doc":"Check if a `number` is within a `range`.\n\n* `number` is either an integer or a float.\n\nWhen an integer, the comparison is made using the standard Elixir `in`\noperator.\n\nWhen `number` is a float the comparison is made using the `>=` and `<=`\noperators on the range endpoints. Note the comparison for a float is only for\nfloats that have no fractional part. If a float has a fractional part then\n`within` returns `false`.\n\n*Since this function is only provided to support plural rules, the float\ncomparison is only useful if the float has no fractional part.*","ref":"Cldr.Math.html#within/2"},{"type":"function","title":"Examples - Cldr.Math.within/2","doc":"iex> Cldr.Math.within(2.0, 1..3)\n    true\n\n    iex> Cldr.Math.within(2.1, 1..3)\n    false","ref":"Cldr.Math.html#within/2-examples"},{"type":"type","title":"Cldr.Math.normalised_decimal/0","doc":"","ref":"Cldr.Math.html#t:normalised_decimal/0"},{"type":"type","title":"Cldr.Math.number_or_decimal/0","doc":"","ref":"Cldr.Math.html#t:number_or_decimal/0"},{"type":"type","title":"Cldr.Math.rounding/0","doc":"","ref":"Cldr.Math.html#t:rounding/0"},{"type":"module","title":"Cldr.String","doc":"Functions that operate on a `String.t` that are not provided\nin the standard lib.","ref":"Cldr.String.html"},{"type":"function","title":"Cldr.String.hash/1","doc":"Hash a string using a polynomial rolling hash function.\n\nSee https://cp-algorithms.com/string/string-hashing.html for\na description of the algoithim.","ref":"Cldr.String.html#hash/1"},{"type":"function","title":"Cldr.String.to_lower_char/1","doc":"","ref":"Cldr.String.html#to_lower_char/1"},{"type":"function","title":"Cldr.String.to_underscore/1","doc":"Replaces \"-\" with \"_\" in a string.","ref":"Cldr.String.html#to_underscore/1"},{"type":"function","title":"Examples - Cldr.String.to_underscore/1","doc":"iex> Cldr.String.to_underscore(\"this-one\")\n    \"this_one\"","ref":"Cldr.String.html#to_underscore/1-examples"},{"type":"function","title":"Cldr.String.to_upper_char/1","doc":"","ref":"Cldr.String.html#to_upper_char/1"},{"type":"function","title":"Cldr.String.underscore/1","doc":"This is the code of Macro.underscore with modifications:\n\nThe change is to cater for strings in the format:\n\n    This_That\n\nwhich in Macro.underscore gets formatted as:\n\n    this__that (note the double underscore)\n\nwhen we actually want:\n\n    that_that","ref":"Cldr.String.html#underscore/1"},{"type":"module","title":"Cldr.Utils","doc":"CLDR Utility functions.","ref":"Cldr.Utils.html"},{"type":"function","title":"Cldr.Utils.otp_version/0","doc":"Returns the current OTP version.","ref":"Cldr.Utils.html#otp_version/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n**Cldr Utils from version 2.18.0 requires Elixir 1.11 or later**","ref":"changelog.html"},{"type":"extras","title":"Cldr Utils version 2.26.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.25.0 released on May 28th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-26-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix warnings on Elixir 1.17. This primarily relates to charlists constants now required to use `sigil_c` to avoid warnings. As a result, tests will only work on Elixir 1.16 and later even though support for the library is for Elixir 1.11 and later.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.25.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.25.0 released on March 20th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-25-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix `Cldr.Math.pow/2` when the exponent is in the range 0 < n < 1.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Cldr.Math.mult/2`, `Cldr.Math.div/2`, `Cldr.Math.add/2` and `Cldr.Math.sub/2` to operate on integers, floats and Decimals.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.24.2 - Changelog","doc":"This is the changelog for Cldr Utils v2.24.2 released on November 2nd, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-24-2"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix depracation warnings for Elixir 1.16.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.24.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.24.1 released on June 17th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-24-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Resolve host certificate stores at runtime, not compile time. Thanks to @joshk for the PR. Closes #7.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.24.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.24.0 released on May 22nd, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-24-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Cldr.Utils.otp_version/0` to return the OTP version as a string. Copied with thanks and appreciation from the `Hex` source.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.23.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.23.0 released on May 4th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-23-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Make parsing `HTTP_PROXY` values more resilient to invalid URLs.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.23.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.23.0 released on May 4th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-23-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds support for https proxy for `Cldr.Http.get/2`. The proxy can be specified as an option to to `Cldr.Http.get/2`, as a configuration option under the `:ex_cldr[:https_proxy]` key, or from the environment variables `HTTPS_PROXY` or `https_proxy`. Thanks to @d-led for the PR and issue.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.22.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.22.0 released on March 25th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-22-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `:timeout` and `:connection_timeout` options to `Cldr.Http.get/2`. The defaults are `[timeout: 60_000, connection_timeout: 120_000]`. The environment variables `CLDR_HTTP_TIMEOUT` and `CLDR_HTTPS_CONNECTION_TIMEOUT` can also be used to set the timeouts. The prededence is `options[:timeout] -> environment variable -> default.`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.21.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.21.0 released on January 27th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-21-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `:verify_peer` as an option to `Cldr.Http.get/1` and `Cldr.Http.get_with_headers/1`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.20.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.20.0 released on January 27th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-20-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Cldr.Http.get_with_headers/1` that will return the headers from the response as well as the body.\n\n* Support headers when sending a request with `Cldr.Http.get/1` and `Cldr.Http.get_with_headers/1`\n\n* Add `:verify_peer` as an option to `Cldr.Http.get/1` and `Cldr.Http.get_with_headers/1`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.19.2 - Changelog","doc":"This is the changelog for Cldr Utils v2.19.2 released on January 25th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-19-2"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Relaxes the requirement for the optional [castore](https://hex.pm/packages/castore) library. Thanks to @maennchen for the PR. Closes #6.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.19.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.19.1 released on August 23rd, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-19-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Use only TLS 1.2 on OTP versions less than 25.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.19.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.19.0 released on August 22nd, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-19-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Sets SNI option for SSL connections\n\n* Supports `CLDR_UNSAFE_HTTPS` environment variable option which, if set to anything other than `FALSE`, `false`, `nil` or `NIL` will not perform peer verification for HTTPS requests. This may be used in circumstances where peer verification is failing but if generally not recommended.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.18.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.18.0 released on July 31st, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n**Cldr Utils now requires Elixir 1.11 or later**\n\n#","ref":"changelog.html#cldr-utils-version-2-18-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix deprecation warnings for Elixir 1.14.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.17.2 - Changelog","doc":"This is the changelog for Cldr Utils v2.17.2 released on May 8th, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-17-2"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Harden the SSL options for `Cldr.Http.get/1` in line with the recommendations at https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.17.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.17.1 released on February 21st, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-17-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix `Cldr.Map.invert/2` to use `Enum.map/2` not `Enum.flat_map/2`","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.17.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.17.0 released on October 27th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-17-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `:duplicates` option to `Cldr.Map.invert/2` to determine how to handle duplicate values after inversion. The options are:\n\n  * `nil` or `false` which is the default and means only one value is kept. `Map.new/1` is used meanng the selected value is non-deterministic.\n  * `:keep` meaning duplicate values are returned in a list\n  * `:shortest` means the shortest duplicate is kept. This operates on string or atom values.\n  * `:longest` means the shortest duplicate is kept. This operates on string or atom values.\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Don't attempt to convert calendar era dates to iso days - do that when required in `ex_cldr_calendars`\n\n* Remove `Cldr.Calendar.Conversion` module which is not required\n\n* Fix `Cldr.Map.deep_map/3` so that the `:filter` option is propogated correctly when `:only/:except` is also specified.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.17.0-rc.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.17.0 released on October 5th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-17-0-rc-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Don't attempt to convert calendar era dates to iso days - do that when required in `ex_cldr_calendars`\n\n* Remove `Cldr.Calendar.Conversion` module which is not required\n\n* Fix `Cldr.Map.deep_map/3` so that the `:filter` option is propogated correctly when `:only/:except` is also specified.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `:duplicates` option to `Cldr.Map.invert/2` to determine how to handle duplicate values after inversion. The options are:\n\n  * `nil` or `false` which is the default and means only one value is kept. `Map.new/1` is used meanng the selected value is non-deterministic.\n  * `:keep` meaning duplicate values are returned in a list\n  * `:shortest` means the shortest duplicate is kept. This operates on string or atom values.\n  * `:longest` means the shortest duplicate is kept. This operates on string or atom values.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.16.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.16.0 released on June 11th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-16-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.Map.extract_strings/2`\n\n* Make resolver a parameter to `Cldr.Map.deep_merge/3`\n\n* Make resolver a parameter to `Cldr.Map.merge_map_list/2`\n\n* Add `Cldr.Map.prune/2` that prunes (deletes) branches from a (possibly deeply nested) map\n\n* Add `Cldr.Map.invert/1` that inverts the `{key, value}` of a map to be `{value, key}` and if `value` is a list, one new map entry for each element of `value` will be created (mapped to `key`)","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.15.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.15.1 released on March 16th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-15-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix `Cldr.Digit.to_number/2` for floats. Thanks for the report from @jlauemoeller. Fixes #15.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.15.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.15.0 released on March 5th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-15-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds the options `:filter`, `:reject` and `:skip` to `Cldr.Map.deep_map/3` that work on entire branches of a map.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.14.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.14.1 released on February 17th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-14-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Merge the fixes from cldr_utils version 2.13.3 for `Cldr.Math.power/2`","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.14.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.14.0 released on November 7th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-14-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Cldr.Http.get/1` to download from `https` URLs using `:httpc` but with certificate vertification enabled (it is not enabled by default in the `:httpc` module).","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.13.3 - Changelog","doc":"This is the changelog for Cldr Utils v2.13.3 released on February 17th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-13-3"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* Fix `Cldr.Math.power/2` when both arguments are Decimal and the power is negative.\n\n* Update the docs for `Cldr.Math.round_significant/2` to note that rounding floats to significant digits cannot always return the expected precision since floats cannot represent all decimal numbers correctly.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.13.2 - Changelog","doc":"This is the changelog for Cldr Utils v2.13.2 released on October 20th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-13-2"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* Fix unused variable warning on OTP versions that do not include `:persistent_term` module. Thanks to @kianmeng.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.13.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.13.1 released on September 30th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-13-1"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.Decimal.parse/1` as a compatibiity layer for Decimal 1.x and 2.x","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.12.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.12.0 released on September 29th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-12-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.Digit.number_of_trailing_zeros/1` to calculate the number of trailing zeros in an integer","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.11.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.11.0 released on September 25th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-11-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Provides `Cldr.Decimal.reduce/1` as a compatibility shim for Decimal 1.x and 2.x\n\n* Provides `Cldr.Decimal.compare/2` as a compatibility shim for Decimal 1.x and 2.x","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.10.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.10.0 released on September 8th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-10-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Supports `Decimal` 1.6 or greater or `Decimal` 2.x or later","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.9.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.9.1 released on May 3rd, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-9-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix compatibility with `ex_cldr` releases up to 2.13.0.  Thanks to @hl for the report. Fixes #3.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.9.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.9.0 released on May 2nd, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-9-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `:level`, `:only` and `:except` options to `Cldr.Map.deep_map/3` and refactor functions that use it\n\n* Add `Cldr.Enum.reduce_peeking/3` that is a simple reduce function that also passed the tail of the enum being reduced to enable a simple form of lookahead\n\n* Refactor `Cldr.Math.round/2` implementation for floating point numbers that improves efficiency by about 100% since it avoids round trip conversion to `Decimal`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.8.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.8.0 released on February 14th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-8-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Be more resilient of the availability of `:persistent_term` given that `get/2`, `get/1` and `:persistent_term` itself are available on different OTP releases. Thanks to @halostatue. Closes #2.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.7.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.7.0 released on January 31st, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-7-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.String.to_underscore/1` that replaces \"-\" with \"_\"","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.6.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.6.0 released on January 21st, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-6-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Support `Decimal` versions `~> 1.6 or 1.9 or 2.0`.  Version 1.9 deprecates `Decimal.compare/2` in favour of `Decimal.cmp/2`. The upcoming `Decimal` version 2.0 deprecates `Decimal.cmp/2` in favour of a new implementation of `Decimal.compare/2` that conforms to Elixir norms and is required to support `Enum.sort/2` correctly.  This version of `cldr_utils` detects the relevant version and adapts accordingly at compile time.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.5.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.5.0 released on October 22nd, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-5-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.Macros.warn_once/3` to log a warning, but only once for a given key","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.4.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.4.0 released on August 23rd, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-4-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.String.hash/1` to implement a polynomial rolling hash function","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.3.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.3.0 released on June 15th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-3-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `doc_since/1` and `calendar_impl/0` to support conditional compilation based upon Elixir versions","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.2.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.2.0 released on March 25th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-2-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Cldr.Math.div_amod/2`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.1.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.1.0 released on March 10th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-1-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* `Cldr.Map.integerize_keys/1` now properly processes negative integer keys. Minor version change to make it easier to peg versions in upstream packages.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.0.5 - Changelog","doc":"This is the changelog for Cldr Utils v2.0.4 released on Jnauary 3rd, 2018.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-0-5"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fixes `Cldr.Math.round/3` for floats when rounding is > 0 digits","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.0.4 - Changelog","doc":"This is the changelog for Cldr Utils v2.0.4 released on Decmber 15th, 2018.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-0-4"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fixes `Cldr.Math.round/3` to be compatible with `Decimal.round/3` and `Kernel.round/1`","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.0.3 - Changelog","doc":"This is the changelog for Cldr Utils v2.0.3 released on Decmber 8th, 2018.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-0-3"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fixed an error in `Cldr.Math.round/3` for `Decimal` numbers where the value being rounded is < 1 but greater than 0 whereby the sign was being returned as `true` instead of `1`.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Cldr Utils version 2.0.2 - Changelog","doc":"This is the changelog for Cldr Utils v2.0.2 released on November 23rd, 2018.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-0-2"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Replace *additional* deprecated `Decimal.new/1` with `Decimal.from_float/1` where required","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.0.1 - Changelog","doc":"This is the changelog for Cldr Utils v2.0.1 released on November 23rd, 2018.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-0-1"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Replace deprecated `Decimal.new/1` with `Decimal.from_float/1` where required","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Utils version 2.0.0 - Changelog","doc":"This is the changelog for Cldr Utils v2.0.0 released on October 29th, 2018.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_utils/tags)\n\n#","ref":"changelog.html#cldr-utils-version-2-0-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Initial release extracted from [ex_cldr](https://hex.pm/packages/ex_cldr)","ref":"changelog.html#enhancements"},{"type":"extras","title":"License","doc":"# License\n\nCopyright (c) 2017-2024 Kip Cole\n\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use this file except in\ncompliance with the License. You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software distributed under the License\nis distributed on an \"AS IS\" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\nimplied. See the License for the specific language governing permissions and limitations under the\nLicense.","ref":"license.html"},{"type":"extras","title":"Cldr Utils","doc":"# Cldr Utils\n\n![Build status](https://github.com/elixir-cldr/cldr_utils/actions/workflows/ci.yml/badge.svg)\n[![Hex.pm](https://img.shields.io/hexpm/v/cldr_utils.svg)](https://hex.pm/packages/cldr_utils)\n[![Hex.pm](https://img.shields.io/hexpm/dw/cldr_utils.svg?)](https://hex.pm/packages/cldr_utils)\n[![Hex.pm](https://img.shields.io/hexpm/dt/cldr_utils.svg?)](https://hex.pm/packages/cldr_utils)\n[![Hex.pm](https://img.shields.io/hexpm/l/cldr_utils.svg)](https://hex.pm/packages/ex_cldr)\n\nUtility functions extracted from [Cldr](https://github.com/elixir-cldr/cldr).\n\n* Map functions for deep mapping, deep merging, transforming keys\n* Math functions including `mod/2` that works on floored division\n* Number functions for working with the number of digits, the fraction as an integer, ...\n* String function for underscoring (converting CamelCase to snake case)\n* Various macros","ref":"readme.html"},{"type":"extras","title":"Installation - Cldr Utils","doc":"The package can be installed by adding `:cldr_utils` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:cldr_utils, \"~> 2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Benchmark - Cldr Utils","doc":"To run the benchmark:\n\n```bash\n$ mix run benchee/decimal.exs\n```","ref":"readme.html#benchmark"},{"type":"extras","title":"Copyright and License - Cldr Utils","doc":"Copyright (c) 2017 Kip Cole\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}